#!/usr/bin/perl

#VARS
$PREF='/usr/local/squidlog4';
$LOGFILE='/var/log/squid';
$year=`date "+%y"`;chomp($year);
$month=`date "+%m"`;chomp($month);
$dbm_m_trafik=$PREF."/db/$year/$month/m-trafik";
$dbm_y_trafik=$PREF."/db/$year/y-trafik";

#init
`mkdir -p $PREF/db/$year/$month`;
`chmod -R 777 $PREF/db/`;
`chown -R nobody:nobody $PREF/db/`;
dbmopen(%m_trafik, $dbm_m_trafik, 0666) || die "Cannot open DBM dbmfile: $!";
dbmopen(%y_trafik, $dbm_y_trafik, 0666) || die "Cannot open DBM dbmfile: $!";

#Load squid log
open FLOG,"<".$LOGFILE."/access.log";@LOG=<FLOG>;close FLOG;
`cat $LOGFILE/access.log >> $LOGFILE/access.bu.log`;
`truncate -s 0 $LOGFILE/access.log`;

#Squid log parse
for ($i=0;$i<@LOG;$i++)
{
  ($tmp,$m,$k,$v)=(split('\s+',$LOG[$i]))[3,5,7,4];
  @sc = split('\/',$tmp);$status = $sc[0];$code = $sc[1];
  if (($m ne 'PUT')&&($k ne '-')&&($code ne '400')&&($code ne '404')&&($status ne 'TCP_DENIED')) 
  { 
  $m_trafik{$k}+=$v;
  $y_trafik{$k}+=$v;
  };
};

dbmclose(%m_trafik);
dbmclose(%y_trafik);

exit 0;
